commit d5cec6de5a72260ffc6b416826b0247a133f90c4
Author: Thomas Schöpping <tschoepp@cit-ec.uni-bielefeld.de>
Date:   Wed Mar 6 12:52:17 2019 +0100

    enhanced UML diagram

diff --git a/docs/AMiRo-LLD.svg b/docs/AMiRo-LLD.svg
index 4038f8e..2ee48fa 100644
--- a/docs/AMiRo-LLD.svg
+++ b/docs/AMiRo-LLD.svg
@@ -1,27 +1,31 @@
-<?xml version="1.0" encoding="UTF-8" standalone="no"?><svg xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink" contentScriptType="application/ecmascript" contentStyleType="text/css" height="256px" preserveAspectRatio="none" style="width:285px;height:256px;" version="1.1" viewBox="0 0 285 256" width="285px" zoomAndPan="magnify"><defs><filter height="300%" id="f1i4ndtq797wdb" width="300%" x="-1" y="-1"><feGaussianBlur result="blurOut" stdDeviation="2.0"/><feColorMatrix in="blurOut" result="blurOut2" type="matrix" values="0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 .4 0"/><feOffset dx="4.0" dy="4.0" in="blurOut2" result="blurOut3"/><feBlend in="SourceGraphic" in2="blurOut3" mode="normal"/></filter></defs><g><!--cluster AMiRoLLD_node--><polygon fill="#FFFFFF" filter="url(#f1i4ndtq797wdb)" points="104,34,114,24,263,24,263,234,253,244,104,244,104,34" style="stroke: #000000; stroke-width: 1.5;"/><line style="stroke: #000000; stroke-width: 1.5;" x1="253" x2="262" y1="34" y2="25"/><line style="stroke: #000000; stroke-width: 1.5;" x1="104" x2="253" y1="34" y2="34"/><line style="stroke: #000000; stroke-width: 1.5;" x1="253" x2="253" y1="34" y2="244"/><text fill="#000000" font-family="sans-serif" font-size="14" font-weight="bold" lengthAdjust="spacingAndGlyphs" textLength="83" x="138" y="49.9951">AMiRo-LLD</text><!--entity periphAL.h--><ellipse cx="177" cy="93" fill="#FEFECE" filter="url(#f1i4ndtq797wdb)" rx="8" ry="8" style="stroke: #A80036; stroke-width: 2.0;"/><text fill="#000000" font-family="sans-serif" font-size="14" lengthAdjust="spacingAndGlyphs" textLength="73" x="140.5" y="122.9951">periphAL.h</text><!--entity AMiRoLLD--><rect fill="#FEFECE" filter="url(#f1i4ndtq797wdb)" height="46.2969" style="stroke: #A80036; stroke-width: 1.5;" width="113" x="120.5" y="182"/><rect fill="#FEFECE" height="10" style="stroke: #A80036; stroke-width: 1.5;" width="15" x="213.5" y="187"/><rect fill="#FEFECE" height="2" style="stroke: #A80036; stroke-width: 1.5;" width="4" x="211.5" y="189"/><rect fill="#FEFECE" height="2" style="stroke: #A80036; stroke-width: 1.5;" width="4" x="211.5" y="193"/><text fill="#000000" font-family="sans-serif" font-size="14" lengthAdjust="spacingAndGlyphs" textLength="73" x="135.5" y="214.9951">AMiRo-LLD</text><!--entity alldconf.h--><ellipse cx="47" cy="93" fill="#FEFECE" filter="url(#f1i4ndtq797wdb)" rx="8" ry="8" style="stroke: #A80036; stroke-width: 2.0;"/><text fill="#000000" font-family="sans-serif" font-size="14" lengthAdjust="spacingAndGlyphs" textLength="66" x="14" y="122.9951">alldconf.h</text><!--link alldconf.h to AMiRoLLD--><path d="M64.2402,108.588 C86.4276,127.362 125.181,160.1527 150.966,181.9712 " fill="none" id="alldconf.h-AMiRoLLD" style="stroke: #A80036; stroke-width: 1.0;"/><path d="M53.2357,110.3553 A9,9 0 0 0 64.1623 97.4437" fill="none" style="stroke: #A80036; stroke-width: 1.5;"/><!--link periphAL.h to AMiRoLLD--><path d="M177,102.268 C177,118.956 177,157.164 177,181.7129 " fill="none" id="periphAL.h-AMiRoLLD" style="stroke: #A80036; stroke-width: 1.0;"/><!--
+<?xml version="1.0" encoding="UTF-8" standalone="no"?><svg xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink" contentScriptType="application/ecmascript" contentStyleType="text/css" height="350px" preserveAspectRatio="none" style="width:453px;height:350px;" version="1.1" viewBox="0 0 453 350" width="453px" zoomAndPan="magnify"><defs><filter height="300%" id="f10c3o16oaiqb9" width="300%" x="-1" y="-1"><feGaussianBlur result="blurOut" stdDeviation="2.0"/><feColorMatrix in="blurOut" result="blurOut2" type="matrix" values="0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 .4 0"/><feOffset dx="4.0" dy="4.0" in="blurOut2" result="blurOut3"/><feBlend in="SourceGraphic" in2="blurOut3" mode="normal"/></filter></defs><g><!--cluster AMiRoLLD_node--><polygon fill="#FFFFFF" filter="url(#f10c3o16oaiqb9)" points="14,26,24,16,431,16,431,328,421,338,14,338,14,26" style="stroke: #000000; stroke-width: 1.5;"/><line style="stroke: #000000; stroke-width: 1.5;" x1="421" x2="430" y1="26" y2="17"/><line style="stroke: #000000; stroke-width: 1.5;" x1="14" x2="421" y1="26" y2="26"/><line style="stroke: #000000; stroke-width: 1.5;" x1="421" x2="421" y1="26" y2="338"/><text fill="#000000" font-family="sans-serif" font-size="14" font-weight="bold" lengthAdjust="spacingAndGlyphs" textLength="83" x="177" y="41.9951">AMiRo-LLD</text><!--entity alldconf.h--><ellipse cx="63" cy="195" fill="#FEFECE" filter="url(#f10c3o16oaiqb9)" rx="8" ry="8" style="stroke: #A80036; stroke-width: 2.0;"/><text fill="#000000" font-family="sans-serif" font-size="14" lengthAdjust="spacingAndGlyphs" textLength="66" x="30" y="224.9951">alldconf.h</text><!--entity periphAL.h--><ellipse cx="251" cy="77" fill="#FEFECE" filter="url(#f10c3o16oaiqb9)" rx="8" ry="8" style="stroke: #A80036; stroke-width: 2.0;"/><text fill="#000000" font-family="sans-serif" font-size="14" lengthAdjust="spacingAndGlyphs" textLength="73" x="214.5" y="106.9951">periphAL.h</text><!--entity periphALtypes.h--><ellipse cx="202" cy="195" fill="#FEFECE" filter="url(#f10c3o16oaiqb9)" rx="8" ry="8" style="stroke: #A80036; stroke-width: 2.0;"/><text fill="#000000" font-family="sans-serif" font-size="14" lengthAdjust="spacingAndGlyphs" textLength="111" x="146.5" y="224.9951">periphALtypes.h</text><!--entity alldh--><ellipse cx="380" cy="195" fill="#FEFECE" filter="url(#f10c3o16oaiqb9)" rx="8" ry="8" style="stroke: #A80036; stroke-width: 2.0;"/><text fill="#000000" font-family="sans-serif" font-size="14" lengthAdjust="spacingAndGlyphs" textLength="71" x="344.5" y="224.9951">amiro-lld.h</text><!--entity AMiRoLLD--><rect fill="#FEFECE" filter="url(#f10c3o16oaiqb9)" height="46.2969" style="stroke: #A80036; stroke-width: 1.5;" width="113" x="194.5" y="284"/><rect fill="#FEFECE" height="10" style="stroke: #A80036; stroke-width: 1.5;" width="15" x="287.5" y="289"/><rect fill="#FEFECE" height="2" style="stroke: #A80036; stroke-width: 1.5;" width="4" x="285.5" y="291"/><rect fill="#FEFECE" height="2" style="stroke: #A80036; stroke-width: 1.5;" width="4" x="285.5" y="295"/><text fill="#000000" font-family="sans-serif" font-size="14" lengthAdjust="spacingAndGlyphs" textLength="73" x="209.5" y="316.9951">AMiRo-LLD</text><!--link alldconf.h to AMiRoLLD--><path d="M80.9775,205.71 C110.9636,223.5741 171.8548,259.8497 212.0356,283.7872 " fill="none" id="alldconf.h-AMiRoLLD" style="stroke: #A80036; stroke-width: 1.0;"/><path d="M70.3836,209.243 A9,9 0 0 0 79.0405 194.7118" fill="none" style="stroke: #A80036; stroke-width: 1.5;"/><!--link periphAL.h to AMiRoLLD--><path d="M259.6459,95.189 C267.5185,112.8284 278.5687,140.5786 283,166 C287.4266,191.3949 287.7162,198.6573 283,224 C279.1009,244.9524 270.1066,267.4344 262.6435,283.7083 " fill="none" id="periphAL.h-AMiRoLLD" style="stroke: #A80036; stroke-width: 1.0;"/><path d="M249.0534,92.3948 A9,9 0 0 0 264.4218 85.33" fill="none" style="stroke: #A80036; stroke-width: 1.5;"/><!--link alldh to AMiRoLLD--><path d="M370.7226,203.0548 C351.485,219.7572 306.6277,258.7031 277.614,283.8933 " fill="none" id="alldh-AMiRoLLD" style="stroke: #A80036; stroke-width: 1.0;"/><!--link periphALtypes.h to AMiRoLLD--><path d="M206.0099,204.1654 C213.5526,221.4059 230.0621,259.1419 240.8462,283.7914 " fill="none" id="periphALtypes.h-AMiRoLLD" style="stroke: #A80036; stroke-width: 1.0;"/><!--link periphAL.h to periphALtypes.h--><path d="M247.1551,86.2593 C239.1044,105.6465 220.3422,150.829 209.7096,176.4339 " fill="none" id="periphAL.h-periphALtypes.h" style="stroke: #A80036; stroke-width: 1.0;"/><path d="M214.8182,186.1843 A9,9 0 0 0 199.197 179.6976" fill="none" style="stroke: #A80036; stroke-width: 1.5;"/><!--
 @startuml
 skinparam componentStyle uml2
 
 
-interface alldconf.h
-
 node "AMiRo-LLD" as AMiRoLLD_node {
+	interface alldconf.h
 	interface periphAL.h
+	interface periphALtypes.h
+	interface "amiro-lld.h" as alldh
 
 	component "AMiRo-LLD" as AMiRoLLD
 	AMiRoLLD -up-( alldconf.h
-	AMiRoLLD -up- periphAL.h
+	AMiRoLLD -up-( periphAL.h
+	AMiRoLLD -up- alldh
+	AMiRoLLD -up- periphALtypes.h
+	periphAL.h - -( periphALtypes.h
 }
 
 @enduml
 
-PlantUML version 1.2018.11(Sat Sep 22 18:43:53 CEST 2018)
+PlantUML version 1.2018.13(Mon Nov 26 18:11:51 CET 2018)
 (GPL source distribution)
 Java Runtime: OpenJDK Runtime Environment
 JVM: OpenJDK 64-Bit Server VM
-Java Version: 1.8.0_181-8u181-b13-1ubuntu0.16.04.1-b13
+Java Version: 10.0.2+13-Ubuntu-1ubuntu0.18.04.4
 Operating System: Linux
-OS Version: 4.15.0-38-generic
+OS Version: 4.15.0-46-generic
 Default Encoding: UTF-8
 Language: en
 Country: US