commit 72369edc914c55785d0654e4aa5bee9a3aed9290
Author: Thomas Schöpping <tschoepp@cit-ec.uni-bielefeld.de>
Date:   Wed Nov 13 14:48:13 2019 +0100

    architecture UML updated

diff --git a/docs/AMiRo-LLD.svg b/docs/AMiRo-LLD.svg
index 2ee48fa..6675206 100644
--- a/docs/AMiRo-LLD.svg
+++ b/docs/AMiRo-LLD.svg
@@ -1,4 +1,4 @@
-<?xml version="1.0" encoding="UTF-8" standalone="no"?><svg xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink" contentScriptType="application/ecmascript" contentStyleType="text/css" height="350px" preserveAspectRatio="none" style="width:453px;height:350px;" version="1.1" viewBox="0 0 453 350" width="453px" zoomAndPan="magnify"><defs><filter height="300%" id="f10c3o16oaiqb9" width="300%" x="-1" y="-1"><feGaussianBlur result="blurOut" stdDeviation="2.0"/><feColorMatrix in="blurOut" result="blurOut2" type="matrix" values="0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 .4 0"/><feOffset dx="4.0" dy="4.0" in="blurOut2" result="blurOut3"/><feBlend in="SourceGraphic" in2="blurOut3" mode="normal"/></filter></defs><g><!--cluster AMiRoLLD_node--><polygon fill="#FFFFFF" filter="url(#f10c3o16oaiqb9)" points="14,26,24,16,431,16,431,328,421,338,14,338,14,26" style="stroke: #000000; stroke-width: 1.5;"/><line style="stroke: #000000; stroke-width: 1.5;" x1="421" x2="430" y1="26" y2="17"/><line style="stroke: #000000; stroke-width: 1.5;" x1="14" x2="421" y1="26" y2="26"/><line style="stroke: #000000; stroke-width: 1.5;" x1="421" x2="421" y1="26" y2="338"/><text fill="#000000" font-family="sans-serif" font-size="14" font-weight="bold" lengthAdjust="spacingAndGlyphs" textLength="83" x="177" y="41.9951">AMiRo-LLD</text><!--entity alldconf.h--><ellipse cx="63" cy="195" fill="#FEFECE" filter="url(#f10c3o16oaiqb9)" rx="8" ry="8" style="stroke: #A80036; stroke-width: 2.0;"/><text fill="#000000" font-family="sans-serif" font-size="14" lengthAdjust="spacingAndGlyphs" textLength="66" x="30" y="224.9951">alldconf.h</text><!--entity periphAL.h--><ellipse cx="251" cy="77" fill="#FEFECE" filter="url(#f10c3o16oaiqb9)" rx="8" ry="8" style="stroke: #A80036; stroke-width: 2.0;"/><text fill="#000000" font-family="sans-serif" font-size="14" lengthAdjust="spacingAndGlyphs" textLength="73" x="214.5" y="106.9951">periphAL.h</text><!--entity periphALtypes.h--><ellipse cx="202" cy="195" fill="#FEFECE" filter="url(#f10c3o16oaiqb9)" rx="8" ry="8" style="stroke: #A80036; stroke-width: 2.0;"/><text fill="#000000" font-family="sans-serif" font-size="14" lengthAdjust="spacingAndGlyphs" textLength="111" x="146.5" y="224.9951">periphALtypes.h</text><!--entity alldh--><ellipse cx="380" cy="195" fill="#FEFECE" filter="url(#f10c3o16oaiqb9)" rx="8" ry="8" style="stroke: #A80036; stroke-width: 2.0;"/><text fill="#000000" font-family="sans-serif" font-size="14" lengthAdjust="spacingAndGlyphs" textLength="71" x="344.5" y="224.9951">amiro-lld.h</text><!--entity AMiRoLLD--><rect fill="#FEFECE" filter="url(#f10c3o16oaiqb9)" height="46.2969" style="stroke: #A80036; stroke-width: 1.5;" width="113" x="194.5" y="284"/><rect fill="#FEFECE" height="10" style="stroke: #A80036; stroke-width: 1.5;" width="15" x="287.5" y="289"/><rect fill="#FEFECE" height="2" style="stroke: #A80036; stroke-width: 1.5;" width="4" x="285.5" y="291"/><rect fill="#FEFECE" height="2" style="stroke: #A80036; stroke-width: 1.5;" width="4" x="285.5" y="295"/><text fill="#000000" font-family="sans-serif" font-size="14" lengthAdjust="spacingAndGlyphs" textLength="73" x="209.5" y="316.9951">AMiRo-LLD</text><!--link alldconf.h to AMiRoLLD--><path d="M80.9775,205.71 C110.9636,223.5741 171.8548,259.8497 212.0356,283.7872 " fill="none" id="alldconf.h-AMiRoLLD" style="stroke: #A80036; stroke-width: 1.0;"/><path d="M70.3836,209.243 A9,9 0 0 0 79.0405 194.7118" fill="none" style="stroke: #A80036; stroke-width: 1.5;"/><!--link periphAL.h to AMiRoLLD--><path d="M259.6459,95.189 C267.5185,112.8284 278.5687,140.5786 283,166 C287.4266,191.3949 287.7162,198.6573 283,224 C279.1009,244.9524 270.1066,267.4344 262.6435,283.7083 " fill="none" id="periphAL.h-AMiRoLLD" style="stroke: #A80036; stroke-width: 1.0;"/><path d="M249.0534,92.3948 A9,9 0 0 0 264.4218 85.33" fill="none" style="stroke: #A80036; stroke-width: 1.5;"/><!--link alldh to AMiRoLLD--><path d="M370.7226,203.0548 C351.485,219.7572 306.6277,258.7031 277.614,283.8933 " fill="none" id="alldh-AMiRoLLD" style="stroke: #A80036; stroke-width: 1.0;"/><!--link periphALtypes.h to AMiRoLLD--><path d="M206.0099,204.1654 C213.5526,221.4059 230.0621,259.1419 240.8462,283.7914 " fill="none" id="periphALtypes.h-AMiRoLLD" style="stroke: #A80036; stroke-width: 1.0;"/><!--link periphAL.h to periphALtypes.h--><path d="M247.1551,86.2593 C239.1044,105.6465 220.3422,150.829 209.7096,176.4339 " fill="none" id="periphAL.h-periphALtypes.h" style="stroke: #A80036; stroke-width: 1.0;"/><path d="M214.8182,186.1843 A9,9 0 0 0 199.197 179.6976" fill="none" style="stroke: #A80036; stroke-width: 1.5;"/><!--
+<?xml version="1.0" encoding="UTF-8" standalone="no"?><svg xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink" contentScriptType="application/ecmascript" contentStyleType="text/css" height="232px" preserveAspectRatio="none" style="width:378px;height:232px;" version="1.1" viewBox="0 0 378 232" width="378px" zoomAndPan="magnify"><defs><filter height="300%" id="f1nvt61nme5tia" width="300%" x="-1" y="-1"><feGaussianBlur result="blurOut" stdDeviation="2.0"/><feColorMatrix in="blurOut" result="blurOut2" type="matrix" values="0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 .4 0"/><feOffset dx="4.0" dy="4.0" in="blurOut2" result="blurOut3"/><feBlend in="SourceGraphic" in2="blurOut3" mode="normal"/></filter></defs><g><!--cluster AMiRoLLD_node--><polygon fill="#FFFFFF" filter="url(#f1nvt61nme5tia)" points="14,26,24,16,356,16,356,210,346,220,14,220,14,26" style="stroke: #000000; stroke-width: 1.5;"/><line style="stroke: #000000; stroke-width: 1.5;" x1="346" x2="355" y1="26" y2="17"/><line style="stroke: #000000; stroke-width: 1.5;" x1="14" x2="346" y1="26" y2="26"/><line style="stroke: #000000; stroke-width: 1.5;" x1="346" x2="346" y1="26" y2="220"/><text fill="#000000" font-family="sans-serif" font-size="14" font-weight="bold" lengthAdjust="spacingAndGlyphs" textLength="83" x="139.5" y="41.9951">AMiRo-LLD</text><!--entity alldconf.h--><ellipse cx="63" cy="77" fill="#FEFECE" filter="url(#f1nvt61nme5tia)" rx="8" ry="8" style="stroke: #A80036; stroke-width: 2.0;"/><text fill="#000000" font-family="sans-serif" font-size="14" lengthAdjust="spacingAndGlyphs" textLength="66" x="30" y="106.9951">alldconf.h</text><!--entity periphAL.h--><ellipse cx="183" cy="77" fill="#FEFECE" filter="url(#f1nvt61nme5tia)" rx="8" ry="8" style="stroke: #A80036; stroke-width: 2.0;"/><text fill="#000000" font-family="sans-serif" font-size="14" lengthAdjust="spacingAndGlyphs" textLength="73" x="146.5" y="106.9951">periphAL.h</text><!--entity alldh--><ellipse cx="305" cy="77" fill="#FEFECE" filter="url(#f1nvt61nme5tia)" rx="8" ry="8" style="stroke: #A80036; stroke-width: 2.0;"/><text fill="#000000" font-family="sans-serif" font-size="14" lengthAdjust="spacingAndGlyphs" textLength="71" x="269.5" y="106.9951">amiro-lld.h</text><!--entity AMiRoLLD--><rect fill="#FEFECE" filter="url(#f1nvt61nme5tia)" height="46.2969" style="stroke: #A80036; stroke-width: 1.5;" width="113" x="126.5" y="166"/><rect fill="#FEFECE" height="10" style="stroke: #A80036; stroke-width: 1.5;" width="15" x="219.5" y="171"/><rect fill="#FEFECE" height="2" style="stroke: #A80036; stroke-width: 1.5;" width="4" x="217.5" y="173"/><rect fill="#FEFECE" height="2" style="stroke: #A80036; stroke-width: 1.5;" width="4" x="217.5" y="177"/><text fill="#000000" font-family="sans-serif" font-size="14" lengthAdjust="spacingAndGlyphs" textLength="73" x="141.5" y="198.9951">AMiRo-LLD</text><!--link alldconf.h to AMiRoLLD--><path d="M79.547,92.4439 C99.9035,111.4433 134.6524,143.8756 158.2042,165.8572 " fill="none" id="alldconf.h-AMiRoLLD" style="stroke: #A80036; stroke-width: 1.0;"/><path d="M68.4993,93.7012 A9,9 0 0 0 80.0403 81.3358" fill="none" style="stroke: #A80036; stroke-width: 1.5;"/><!--link periphAL.h to AMiRoLLD--><path d="M183,96.4286 C183,115.7136 183,145.2823 183,165.7914 " fill="none" id="periphAL.h-AMiRoLLD" style="stroke: #A80036; stroke-width: 1.0;"/><path d="M174.5428,89.2437 A9,9 0 0 0 191.4573 89.2435" fill="none" style="stroke: #A80036; stroke-width: 1.5;"/><!--link alldh to AMiRoLLD--><path d="M295.8302,85.4182 C277.4324,102.308 235.4524,140.847 208.2091,165.8572 " fill="none" id="alldh-AMiRoLLD" style="stroke: #A80036; stroke-width: 1.0;"/><!--
 @startuml
 skinparam componentStyle uml2
 
@@ -6,26 +6,23 @@ skinparam componentStyle uml2
 node "AMiRo-LLD" as AMiRoLLD_node {
 	interface alldconf.h
 	interface periphAL.h
-	interface periphALtypes.h
 	interface "amiro-lld.h" as alldh
 
 	component "AMiRo-LLD" as AMiRoLLD
 	AMiRoLLD -up-( alldconf.h
 	AMiRoLLD -up-( periphAL.h
 	AMiRoLLD -up- alldh
-	AMiRoLLD -up- periphALtypes.h
-	periphAL.h - -( periphALtypes.h
 }
 
 @enduml
 
-PlantUML version 1.2018.13(Mon Nov 26 18:11:51 CET 2018)
+PlantUML version 1.2019.08(Sat Jul 13 21:25:14 CEST 2019)
 (GPL source distribution)
 Java Runtime: OpenJDK Runtime Environment
 JVM: OpenJDK 64-Bit Server VM
-Java Version: 10.0.2+13-Ubuntu-1ubuntu0.18.04.4
+Java Version: 11.0.4+11-post-Ubuntu-1ubuntu218.04.3
 Operating System: Linux
-OS Version: 4.15.0-46-generic
+OS Version: 4.15.0-66-generic
 Default Encoding: UTF-8
 Language: en
 Country: US
diff --git a/docs/AMiRo-LLD.uml b/docs/AMiRo-LLD.uml
index fda041a..fab69ad 100644
--- a/docs/AMiRo-LLD.uml
+++ b/docs/AMiRo-LLD.uml
@@ -26,15 +26,12 @@ skinparam componentStyle uml2
 node "AMiRo-LLD" as AMiRoLLD_node {
 	interface alldconf.h
 	interface periphAL.h
-	interface periphALtypes.h
 	interface "amiro-lld.h" as alldh
 
 	component "AMiRo-LLD" as AMiRoLLD
 	AMiRoLLD -up-( alldconf.h
 	AMiRoLLD -up-( periphAL.h
 	AMiRoLLD -up- alldh
-	AMiRoLLD -up- periphALtypes.h
-	periphAL.h --( periphALtypes.h
 }
 
 @enduml