commit ded1ded74770be5d73034e4f0bc949f570271b5e
Author: Thomas Schöpping <tschoepp@cit-ec.uni-bielefeld.de>
Date:   Wed Jul 29 11:24:12 2020 +0200

    VL53L1X test overhauled.
    - AMiRo-LLD updated
    - periphAL implementation adapted
    - NUCLEO-L476RG module configuration modified
    - VL53L1X test reworked (still wip)

diff --git a/modules/NUCLEO-L476RG/board.h b/modules/NUCLEO-L476RG/board.h
index 8ea74b7..b84c677 100644
--- a/modules/NUCLEO-L476RG/board.h
+++ b/modules/NUCLEO-L476RG/board.h
@@ -62,8 +62,7 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
 /*
  * Identifiers for optional peripherals.
  */
-#define BOARD_MPU6050_CONNECTED     false
-
+#define BOARD_MPU6050_CONNECTED     true
 #define BOARD_VL53L1X_CONNECTED     true
 
 
@@ -463,8 +462,8 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
  * PB5  - ARD_D4                    (analog).
  * PB6  - ARD_D10                   (analog).
  * PB7  - PIN7                      (analog).
- * PB8  - ARD_D15                   (analog).
- * PB9  - ARD_D14                   (analog).
+ * PB8  - ARD_D15                   (alternate 4).
+ * PB9  - ARD_D14                   (alternate 4).
  * PB10 - ARD_D6                    (analog).
  * PB11 - PIN11                     (analog).
  * PB12 - PIN12                     (analog).
@@ -480,8 +479,8 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
                                      PIN_MODE_ANALOG(GPIOB_ARD_D4) |        \
                                      PIN_MODE_ANALOG(GPIOB_ARD_D10) |       \
                                      PIN_MODE_ANALOG(GPIOB_PIN7) |          \
-                                     PIN_MODE_ANALOG(GPIOB_ARD_D15) |       \
-                                     PIN_MODE_ANALOG(GPIOB_ARD_D14) |       \
+                                     PIN_MODE_ALTERNATE(GPIOB_ARD_D15) |    \
+                                     PIN_MODE_ALTERNATE(GPIOB_ARD_D14) |    \
                                      PIN_MODE_ANALOG(GPIOB_ARD_D6) |        \
                                      PIN_MODE_ANALOG(GPIOB_PIN11) |         \
                                      PIN_MODE_ANALOG(GPIOB_PIN12) |         \
@@ -496,8 +495,8 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
                                      PIN_OTYPE_PUSHPULL(GPIOB_ARD_D4) |     \
                                      PIN_OTYPE_PUSHPULL(GPIOB_ARD_D10) |    \
                                      PIN_OTYPE_PUSHPULL(GPIOB_PIN7) |       \
-                                     PIN_OTYPE_PUSHPULL(GPIOB_ARD_D15) |    \
-                                     PIN_OTYPE_PUSHPULL(GPIOB_ARD_D14) |    \
+                                     PIN_OTYPE_OPENDRAIN(GPIOB_ARD_D15) |   \
+                                     PIN_OTYPE_OPENDRAIN(GPIOB_ARD_D14) |   \
                                      PIN_OTYPE_PUSHPULL(GPIOB_ARD_D6) |     \
                                      PIN_OTYPE_PUSHPULL(GPIOB_PIN11) |      \
                                      PIN_OTYPE_PUSHPULL(GPIOB_PIN12) |      \
@@ -528,8 +527,8 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
                                      PIN_PUPDR_FLOATING(GPIOB_ARD_D4) |     \
                                      PIN_PUPDR_FLOATING(GPIOB_ARD_D10) |    \
                                      PIN_PUPDR_FLOATING(GPIOB_PIN7) |       \
-                                     PIN_PUPDR_FLOATING(GPIOB_ARD_D15) |    \
-                                     PIN_PUPDR_FLOATING(GPIOB_ARD_D14) |    \
+                                     PIN_PUPDR_PULLUP(GPIOB_ARD_D15) |      \
+                                     PIN_PUPDR_PULLUP(GPIOB_ARD_D14) |      \
                                      PIN_PUPDR_FLOATING(GPIOB_ARD_D6) |     \
                                      PIN_PUPDR_FLOATING(GPIOB_PIN11) |      \
                                      PIN_PUPDR_FLOATING(GPIOB_PIN12) |      \
@@ -560,8 +559,8 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
                                      PIN_AFIO_AF(GPIOB_ARD_D4, 0U) |        \
                                      PIN_AFIO_AF(GPIOB_ARD_D10, 0U) |       \
                                      PIN_AFIO_AF(GPIOB_PIN7, 0U))
-#define VAL_GPIOB_AFRH              (PIN_AFIO_AF(GPIOB_ARD_D15, 0U) |       \
-                                     PIN_AFIO_AF(GPIOB_ARD_D14, 0U) |       \
+#define VAL_GPIOB_AFRH              (PIN_AFIO_AF(GPIOB_ARD_D15, 4U) |       \
+                                     PIN_AFIO_AF(GPIOB_ARD_D14, 4U) |       \
                                      PIN_AFIO_AF(GPIOB_ARD_D6, 0U) |        \
                                      PIN_AFIO_AF(GPIOB_PIN11, 0U) |         \
                                      PIN_AFIO_AF(GPIOB_PIN12, 0U) |         \