commit 1a8fb642109d531654731bb3c38a8482a5048343
Author: Thomas Schöpping <tschoepp@cit-ec.uni-bielefeld.de>
Date:   Thu Oct 31 14:35:08 2019 +0100

    Renamed all GPIO related signals etc. from "...io..." to "...gpio..."

diff --git a/modules/NUCLEO-F103RB/module.h b/modules/NUCLEO-F103RB/module.h
index 7eca5c1..f7d89d5 100644
--- a/modules/NUCLEO-F103RB/module.h
+++ b/modules/NUCLEO-F103RB/module.h
@@ -147,13 +147,13 @@ extern ROMCONST apalControlGpio_t moduleGpioUserButton;
 /**
  * @brief   Event flag to be call dwt_isr() interrupt.
  */
-#define MODULE_OS_IOEVENTFLAGS_DW1000_IRQn      AOS_IOEVENT_FLAG(PAL_PAD(LINE_ARD_D14))
+#define MODULE_OS_GPIOEVENTFLAG_DW1000_IRQn     AOS_GPIOEVENT_FLAG(PAL_PAD(LINE_ARD_D14))
 //#endif /* (BOARD_DW1000_CONNECTED == true) */
 
 /**
  * @brief   Event flag to be set on a USER_BUTTON interrupt.
  */
-#define MODULE_OS_IOEVENTFLAGS_USERBUTTON       AOS_IOEVENT_FLAG(PAL_PAD(LINE_BUTTON))
+#define MODULE_OS_GPIOEVENTFLAG_USERBUTTON      AOS_GPIOEVENT_FLAG(PAL_PAD(LINE_BUTTON))
 
 #if (AMIROOS_CFG_SHELL_ENABLE == true) || defined(__DOXYGEN__)
 /**
@@ -168,13 +168,13 @@ extern ROMCONST char* moduleShellPrompt;
  */
 #define MODULE_INIT_INTERRUPTS() {                                            \
   /* user button */                                                           \
-  palSetLineCallback(moduleGpioUserButton.gpio->line, aosSysGetStdExtiCallback(), &moduleGpioUserButton.gpio->line);  \
+  palSetLineCallback(moduleGpioUserButton.gpio->line, aosSysGetStdGpioCallback(), &moduleGpioUserButton.gpio->line);  \
   palEnableLineEvent(moduleGpioUserButton.gpio->line, APAL2CH_EDGE(moduleGpioUserButton.meta.edge));                  \
   MODULE_INIT_INTERRUPTS_DW1000();                                            \
 }
 #if (BOARD_DW1000_CONNECTED == true)
   #define MODULE_INIT_INTERRUPTS_DW1000() {                                   \
-    palSetLineCallback(moduleGpioDw1000Irqn.gpio->line, aosSysGetStdExtiCallback(), &moduleGpioDw1000Irqn.gpio->line);  \
+    palSetLineCallback(moduleGpioDw1000Irqn.gpio->line, aosSysGetStdGpioCallback(), &moduleGpioDw1000Irqn.gpio->line);  \
     palEnableLineEvent(moduleGpioDw1000Irqn.gpio->line, APAL2CH_EDGE(moduleGpioDw1000Irqn.meta.edge));                  \
   }
 #else /* (BOARD_DW1000_CONNECTED == true) */
@@ -187,7 +187,7 @@ extern ROMCONST char* moduleShellPrompt;
  * @brief   Test initialization hook.
  */
 #define MODULE_INIT_TESTS() {                                                 \
-  /* initialize tests and add to shell */                                     \
+  /* add test commands to shell */                                            \
   aosShellAddCommand(&aos.shell, &moduleTestLedShellCmd);                     \
   aosShellAddCommand(&aos.shell, &moduleTestButtonShellCmd);                  \
   MODULE_INIT_TESTS_DW1000();                                                 \
@@ -228,6 +228,7 @@ extern ROMCONST char* moduleShellPrompt;
  */
 #define MODULE_SHUTDOWN_PERIPHERY_IF() {                                      \
   MODULE_SHUTDOWN_PERIPHERY_IF_DW1000();                                      \
+  /* don't stop the serial driver so messages can still be printed */         \
 }
 #if (BOARD_DW1000_CONNECTED == true)
 #define MODULE_SHUTDOWN_PERIPHERY_IF_DW1000() {                               \
@@ -242,26 +243,26 @@ extern ROMCONST char* moduleShellPrompt;
 /**
  * @brief   HOOK to toggle the LEDs when the user button is pressed.
  */
-#define MODULE_MAIN_LOOP_IO_EVENT(eventflags) {                               \
-  if (eventflags & MODULE_OS_IOEVENTFLAGS_USERBUTTON) {                       \
+#define MODULE_MAIN_LOOP_GPIOEVENT(eventflags) {                              \
+  if (eventflags & MODULE_OS_GPIOEVENTFLAG_USERBUTTON) {                      \
     apalControlGpioState_t buttonstate;                                       \
     apalControlGpioGet(&moduleGpioUserButton, &buttonstate);                  \
     apalControlGpioSet(&moduleGpioLed, buttonstate);                          \
   }                                                                           \
-  MODULE_MAIN_LOOP_IO_EVENT_DW1000();                                         \
+  MODULE_MAIN_LOOP_GPIOEVENT_DW1000();                                        \
 }
 #if (BOARD_DW1000_CONNECTED == true)
   /**
    * @brief   HOOK to call process_deca_irq() func when the dw1000 interrupt pin is activated.
    */
-  #define MODULE_MAIN_LOOP_IO_EVENT_DW1000() {                                \
-    if(eventflags & MODULE_OS_IOEVENTFLAGS_DW1000_IRQn) {                     \
+  #define MODULE_MAIN_LOOP_GPIOEVENT_DW1000() {                               \
+    if(eventflags & MODULE_GPOS_IOEVENTFLAG_DW1000_IRQn) {                    \
       /*apalGpioToggle(moduleGpioLed.gpio);*/ /* just for debug*/             \
       process_deca_irq();                                                     \
     }                                                                         \
   }
 #else /* (BOARD_DW1000_CONNECTED == true) */
-  #define MODULE_MAIN_LOOP_IO_EVENT_DW1000() {                                \
+  #define MODULE_MAIN_LOOP_GPIOEVENT_DW1000() {                               \
   }
 #endif /* (BOARD_DW1000_CONNECTED == true) */
 